#!/usr/bin/env node

/*
Copyright 2026 Seekra

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import { processPlugin } from './utils/plugin.js';
import { readdir, rm } from 'node:fs/promises';
import { join } from 'node:path';
import { pathToFileURL } from 'node:url';
import { parseArgs } from 'node:util';

const dir = './build/plugins';

const files = await readdir(dir);

const tryToProcessPlugin = async function tryToProcessPlugin (plugin, options) {
    if (typeof plugin.default === 'function') {
        await processPlugin(plugin.default, options);
    }
};

const { values: args } = parseArgs({
    options: {
        distBase: {
            type: 'string',
            short: 'd',
            default: './dist/'
        },
        srcBase: {
            type: 'string',
            short: 's',
            default: './src/'
        }
    }
});

await rm(args.distBase, {
    recursive: true,
    force: true
});

(await Promise.all(
    files
        .filter((file) => file.endsWith('.js'))
        .map((file) =>
            import(pathToFileURL(join(dir, file)).href)
        )
)).forEach(
    async (plugin) => tryToProcessPlugin(plugin, {
        srcBase: args.srcBase,
        distBase: args.distBase
    })
);